* modifikcia pre priame prilinkovanie ku RAUKN

/*
 ķ
   Program..: _DCQUERY.PRG                          
   Author...: Roger J. Donnay                       
   Notice...: (c) DONNAY Software Designs 1987-1996 
   Date.....: Jun 28, 1996                          
   Notes....: Query builder                         
   Functions: dc_query(),                           
              dc_querya2s(), dc_querys2a()          
              dc_like(), dc_endswith(), dc_range()  
              dc_queryfile()                        
 Ľ
*/

* modify V.L. 1.8.2016 - zmena fontu z 8.Alaska CRT na fontnt, aby dobre zobrazovalo diakritiku pri stave dotazu
* modify V.L. 27.4.2015 - 4.5.2015 , translate to slovak
* vytvorenia nov funkcia DC_QueryBuild_sk(), pvodn ponechan bez zmeny

#include "dccolor.ch"
*#include "dcmouse.ch"
*#include "inkey.ch"
#include "_dcquery.ch"
*#include "IK50.ch"
#include "_dcscope.ch"
*#INCLUDE "dcdialog.CH"
*#INCLUDE "appevent.CH"
#INCLUDE "dcfields.CH"
#include "dcscope.ch"

*STATIC aDCQuery := { '', 'DCQUERY' }

#define nDCQUERY_PICKOPERATION     1
#define nDCQUERY_PICKFIELD         2
#define nDCQUERY_PICKOPERATOR      3
#define nDCQUERY_PICKVALUE         4
#define nDCQUERY_PICKLOGICAL       5
#define nDCQUERY_PICKQUERY         6
#define nDCQUERY_PICKDELETED       7
#define nDCQUERY_PICKTAGGED        8
#define nDCQUERY_PICKEXPRESSION    9
#define nDCQUERY_DELETEQUERY       10
#define nDCQUERY_SELECTQUERY       11


#define cDCQUERY_QUERYEXPRESSION   aQueryBuild[1]
#define aDCQUERY_GETLIST           aQueryBuild[2]
#define cDCQUERY_ANDOR             aQueryBuild[3]
#define cDCQUERY_FIELDNAME         aQueryBuild[4]
#define cDCQUERY_FIELDTYPE         aQueryBuild[5]
#define cDCQUERY_FIELDDESC         aQueryBuild[6]
#define nDCQUERY_FIELDLEN          aQueryBuild[7]
#define oDCQUERY_MEMOOBJECT        aQueryBuild[8]
#define oDCQUERY_VALUESTATIC       aQueryBuild[9]
#define cDCQUERY_OPERATOR          aQueryBuild[10]
#define cDCQUERY_OPERATION         aQueryBuild[11]
#define cDCQUERY_QUERYNAME         aQueryBuild[12]
#define cDCQUERY_ANDOR_BUTTON      aQueryBuild[13]
#define cDCQUERY_OPERATION_BUTTON  aQueryBuild[14]
#define aDCQUERY_GETLIST2          aQueryBuild[15]
#define aDCQUERY_QUERYARRAY        aQueryBuild[16]
#define cDCQUERY_QUERYPICKEXPR     aQueryBuild[17]
#define oDCQUERY_BROW_FIELDS       aQueryBuild[18]
#define oDCQUERY_BROW_OPERATORS    aQueryBuild[19]
#define oDCQUERY_BROW_QUERY        aQueryBuild[20]
#define lDCQUERY_QUICK_QUERY       aQueryBuild[21]


#define cQUERYFILE        aDCQuery[1]
#define cQUERYALIAS       aDCQuery[2]

/* ------------ */

FUNCTION dc_querya2s ( aQuery )

LOCAL i, cString := '', cField, cType, cOperator, cValue1, cValue2, ;
      cPre, cPost, cString2, cDesc, lExpr1, lExpr2

* { cField, cOperator, cValue1, cValue2, cPre, cPost, cDesc, lExpr1, lExpr2 }

aQuery := IIF(Valtype(aQuery)='A',aQuery,{})

FOR i := 1 TO LEN(aQuery)

  ASIZE( aQuery[i],9 )
  cField    := UPPER(ALLTRIM(aQuery[i,1]))
  cType     := TYPE(cField)
  cOperator := ALLTRIM(UPPER(aQuery[i,2]))
  cValue1   := IIF(!EMPTY(aQuery[i,3]),ALLTRIM(aQuery[i,3]),'')
  cValue2   := IIF(!EMPTY(aQuery[i,4]),ALLTRIM(aQuery[i,4]),'')
  cPre      := IIF(!EMPTY(aQuery[i,5]),ALLTRIM(aQuery[i,5]),'')
  cPost     := IIF(!EMPTY(aQuery[i,6]),ALLTRIM(UPPER(aQuery[i,6])),;
               IIF(i<LEN(aQuery),'.AND.',''))
  cDesc     := IIF(!EMPTY(aQuery[i,7]),ALLTRIM(aQuery[i,7]),'')
  lExpr1    := IIF(!EMPTY(aQuery[i,8]),lExpr1,.f.)
  lExpr2    := IIF(!EMPTY(aQuery[i,9]),lExpr2,.f.)
  cString2  := ''

  IF 'X' $ cType
    cField := Strtran(cField,'[x]',cValue1)
    cField := Strtran(cField,'[y]',cValue2)
  ENDIF

  DO CASE

    CASE ' ' + cOperator + ' ' $ ;
           '   =   ==   <>    #    <    >    $   !$   <=   >= '
         *  12345123451234512345123451234512345123451234512345
      DO CASE
        CASE cType $ 'CM'
          IF !lExpr1
            cValue1 := '"' + UPPER(cValue1) + '"'
          ENDIF
          IF '$' $ cOperator
            cString2 :=  cValue1 + cOperator + 'UPPER('+ cField +')'
          ELSE
            cString2 := 'UPPER('+ cField +')' + cOperator + cValue1
          ENDIF
        CASE cType = 'N'
          cString2 := cField + cOperator + cValue1
        CASE cType = 'D'
          cString2 := cField + cOperator + 'CTOD("'+cValue1+'")'
      ENDCASE

    CASE cOperator == 'DOW'
      cString2 := 'DOW(' + cField + ')=' + cValue1

    CASE cOperator == 'DAY'
      cString2 := 'DAY(' + cField + ')=' + cValue1

    CASE cOperator == 'MON'
      cString2 := 'MONTH(' + cField + ')=' + cValue1

    CASE cOperator == 'YR'
      cString2 := 'YEAR(' + cField + ')=' + cValue1

    CASE cOperator == 'EM'
      cString2 := 'EMPTY(' + cField + ')'

    CASE cOperator == '!EM'
      cString2 := '!EMPTY(' + cField + ')'

    CASE cOperator == 'END'
      IF 'X' $ cType
        cString2 := 'DC_ENDSWITH(' + cField + '")'
      ELSE
        cString2 := 'DC_ENDSWITH(' + cField + ',"' + cValue1 + '")'
      ENDIF
    CASE cOperator == 'DEL'
      cString2 := 'DELETED()'

    CASE cOperator == 'TAG'
      cString2 := IIF(TYPE('DCTAGS')='A','DC_TAGGED()','TAG')

    CASE cOperator == 'SL'
      IF 'X' $ cType
        cString2 := 'DC_LIKE(' + cField + '")'
      ELSE
        cString2 := 'DC_LIKE(' + cField + ',"' + cValue1 + '")'
      ENDIF

    CASE cOperator == 'RAN'
      DO CASE
        CASE 'X' $ cType
          cField := Strtran(cField,'[x]',cValue1)
          cField := Strtran(cField,'[y]',cValue2)
          cString2 := 'DC_RANGE(' + cField + ')'
        CASE cType = 'N'
          cString2 := 'DC_RANGE(' + cField + ',' + cValue1 + ',' + cValue2 + ')'
        CASE cType $ 'CM'
          cString2 := 'DC_RANGE(' + cField + ',"' + cValue1 + '","' + cValue2 + '")'
        CASE cType = 'D'
          cString2 := 'DC_RANGE(' + cField + ',CTOD("' + cValue1 + '"),CTOD("' + cValue2 + '"))'
      ENDCASE

  ENDCASE

  cString += cPre + cString2 + cPost

NEXT
RETURN cString

/* ------------ */

FUNCTION dc_querys2a ( cQuery )

LOCAL i, aQuery := {}, cString, cChar, aExpr, lExact := SET(_SET_EXACT,.f.),;
      lEndExpr, cPre, cPost, nLeftParen := 0 , nRightParen := 0

DC_VALTYPE( @cQuery, '' )

DC_DICTCHECK()
cQuery := ALLTRIM(cQuery)
cString := ''
i := 1
STORE '' TO cPre, cPost
DO WHILE i <= LEN(cQuery)
  lEndExpr := .f.
  cChar := SUBSTR(cQuery,i,1)
  DO CASE
    CASE cChar = '!' .AND. i=1
      cPre += '!'
      cQuery := SUBSTR(cQuery,2)
      i := 0
    CASE cChar = '(' .AND. i=1
      cPre += '('
      nLeftParen := 0
      cQuery := SUBSTR(cQuery,2)
      i := 0
    CASE cChar = '('
      nLeftParen++
      cString += cChar
    CASE cChar = ')'
      nRightParen++
      IF nRightParen > nLeftParen
        cPost += ')'
      ELSE
        cString += cChar
      ENDIF
    CASE cChar = '.'
      DO CASE
        CASE UPPER(SUBSTR(cQuery,i,5)) = '.AND.'
          cPost += '.AND.'
          i += 4
          lEndExpr := .t.
        CASE UPPER(SUBSTR(cQuery,i,4)) = '.OR.'
          cPost += '.OR.'
          i += 3
          lEndExpr := .t.
        OTHERWISE
          cString += cChar
      ENDCASE
    OTHERWISE
      cString += cChar
  ENDCASE
  i++
  IF lEndExpr .OR. i > LEN(cQuery)
    aExpr := _DCEXPRARRAY( cString )
    AADD( aQuery, { aExpr[1], aExpr[2], aExpr[3], aExpr[4], cPre, cPost, ;
                    DC_DictTran( aExpr[1], .t. ), aExpr[5], aExpr[6] } )
    STORE '' TO cString, cPre, cPost
    STORE 0 TO nLeftParen, nRightParen
    cQuery := ALLTRIM(SUBSTR(cQuery,i))
    i := 1
  ENDIF
ENDDO
SET(_SET_EXACT,lExact)
RETURN aQuery

/* ------------ */

STATIC FUNCTION _dcexprarray ( cString )

LOCAL i, nLeftParen := 0, nRightParen := 0, cChar, cField, cOper, ;
      cValue1, cValue2, lEnd, cTemp, lExpr1, lExpr2, cLastChar

STORE '' TO cField, cOper, cValue1, cValue2, cLastChar, cChar

i := 1
DO WHILE i <= LEN(cString)
  cLastChar := cChar
  cChar := SUBSTR(cString,i,1)
  lEnd := .f.
  DO CASE
    CASE cChar = '('
      nLeftParen++
      cField += cChar
    CASE cChar = ')'
      nRightParen++
      cField += cChar
      IF nRightParen = nLeftParen
        lEnd := .t.
      ENDIF
    CASE cChar $ '<>#$=' .AND. cLastChar # '-'
      lEnd := .t.
      cOper := cChar
    OTHERWISE
      cField += cChar
  ENDCASE
  i++
  IF lEnd
    cString := ALLTRIM(SUBSTR(cString,i))
    i := 1
    DO WHILE i <= LEN(cString)
      cChar := SUBSTR(cString,i,1)
      lEnd := .f.
      DO CASE
        CASE !( cChar $ '<>#$=' .AND. cLastChar # '-' )
          lEnd := .t.
        OTHERWISE
          cOper += cChar
      ENDCASE
      IF lEnd
        cValue1 := SUBSTR(cString,i)
        i := LEN(cString)
      ENDIF
      i++
    ENDDO
  ENDIF
ENDDO
IF ALLTRIM(cOper) = '$'
  cTemp := cValue1
  cValue1 := cField
  cField := cTemp
ENDIF
cField := ALLTRIM(cField)
cValue1 := ALLTRIM(cValue1)
cValue2 := ALLTRIM(cValue2)
DO CASE
  CASE UPPER(cField) = 'DC_ENDSWITH('
    _DCPARSEVAL( cField, @cField, @cValue1, @cValue2 )
    cOper := 'END'
  CASE UPPER(cField) = 'DC_LIKE('
    _DCPARSEVAL( cField, @cField, @cValue1, @cValue2 )
    cOper := 'SL'
  CASE UPPER(cField) = 'DC_RANGE('
    _DCPARSEVAL( cField, @cField, @cValue1, @cValue2 )
    cOper := 'RAN'
  CASE UPPER(cField) = 'UPPER('
    cField := SUBSTR(cField,7)
    cField := SUBSTR(cField,1,LEN(cField)-1)
  CASE UPPER(cField) = 'DAY('
    _DCPARSEVAL( cField, @cField )
    cOper := 'DAY'
  CASE UPPER(cField) = 'DOW('
    _DCPARSEVAL( cField, @cField )
    cOper := 'DOW'
  CASE UPPER(cField) = 'MONTH('
    _DCPARSEVAL( cField, @cField )
    cOper := 'MON'
  CASE UPPER(cField) = 'YEAR('
    _DCPARSEVAL( cField, @cField )
    cOper := 'YR'
  CASE UPPER(cField) = 'EMPTY('
    _DCPARSEVAL( cField, @cField )
    cOper := 'EM'
  CASE UPPER(cField) = '!EMPTY('
    _DCPARSEVAL( cField, @cField )
    cOper := '!EM'
  CASE UPPER(cField) = 'DC_TAGGED('
    cOper := 'TAG'
    cField := ''
  CASE UPPER(cField) = 'TAG'
    cOper := 'TAG'
    cField := ''
  CASE UPPER(cField) = 'DELETED('
    cOper := 'DEL'
    cField := ''
ENDCASE
STORE .t. TO lExpr1, lExpr2
IF cValue1 = 'CTOD('
  cValue1 := SUBSTR(cValue1,6)
  cValue1 := SUBSTR(cValue1,1,LEN(cValue1)-1)
ENDIF
IF cValue2 = 'CTOD('
  cValue2 := SUBSTR(cValue2,6)
  cValue2 := SUBSTR(cValue2,1,LEN(cValue2)-1)
ENDIF
IF LEFT(cValue1,1)='"'.AND.RIGHT(cValue1,1)='"'
  cValue1 := STRTRAN(cValue1,'"','')
  lExpr1 := .f.
ENDIF
IF LEFT(cValue2,1)='"'.AND.RIGHT(cValue2,1)='"'
  cValue2 := STRTRAN(cValue2,'"','')
  lExpr2 := .f.
ENDIF
IF LEFT(cValue1,1)="'".AND.RIGHT(cValue1,1)="'"
  cValue1 := STRTRAN(cValue1,"'","")
  lExpr1 := .f.
ENDIF
IF LEFT(cValue2,1)="'".AND.RIGHT(cValue2,1)="'"
  cValue2 := STRTRAN(cValue2,"'","")
  lExpr2 := .f.
ENDIF
RETURN { ALLTRIM(cField), ALLTRIM(cOper), ALLTRIM(cValue1), ;
         ALLTRIM(cValue2), lExpr1, lExpr2 }

* ------------

STATIC PROCEDURE _dcparseval ( cString, cField, cValue1, cValue2 )
STORE '' TO cField, cValue1, cValue2
cString := SUBSTR(cString,AT('(',cString)+1)
cString := SUBSTR(cString,1,LEN(cString)-1)
cField := ALLTRIM(DC_TXTWORD(cString,1,','))
cValue1 := ALLTRIM(DC_TXTWORD(cString,2,','))
cValue2 := ALLTRIM(DC_TXTWORD(cString,3,','))
RETURN

* ------------

FUNCTION dc_range ( xValue, xRange1, xRange2 )

RETURN xValue >= xRange1 .AND. xValue <= xRange2

* ------------

FUNCTION dc_endswith ( cString, cSubstring )

RETURN RIGHT(ALLTRIM(cString),LEN(cSubstring))==cSubstring

* ------------

FUNCTION dc_queryfile ( cFileName, cAlias )

IF VALTYPE(cFileName)='C'
  cQUERYFILE := ALLTRIM(UPPER(cFileName))
ENDIF
IF Valtype(cAlias)='C'
  cQUERYALIAS := ALLTRIM(UPPER(cAlias))
ENDIF
RETURN cQUERYFILE

* ------------

FUNCTION DC_QueryBuild ( cQueryExpr, cQueryName, cField, aFieldItems )

LOCAL nSequence, GetList := {}, oFileMenu, oMenuBar, bQueryAction, ;
      cOldQuery, aQueryBuild[21], oOperationStatic, oFieldsStatic, ;
      nFieldPointer, oLogicalStatic, oQueryCatalogStatic, ;
      nOperatorPointer, aFields, aOperators, i, ;
      oOperatorStatic, lOk, GetOptions, bFieldAction, bOperatorAction, ;
      oAndButton, oOrButton, oAndNotButton, oOrNotButton, oFieldButton, ;
      oQueryButton, oTaggedButton, oDeletedButton

STORE '' TO cDCQUERY_FIELDTYPE, cDCQUERY_OPERATOR, cDCQUERY_ANDOR, ;
            cDCQUERY_FIELDNAME, cDCQUERY_FIELDDESC

DEFAULT cQueryName := '<no name>', ;
        cQueryExpr := dbFilter()

nFieldPointer := 1

IF !_DCQueryOpen()
  RETURN ''
ENDIF

aDCQUERY_QUERYARRAY := {''}

IF !EMPTY(cField)
  cDCQUERY_QUERYEXPRESSION := ''
ELSE
  cDCQUERY_QUERYEXPRESSION := Alltrim(cQueryExpr)
ENDIF

IF !Empty(cQueryExpr)
  AAdd(aDCQUERY_QUERYARRAY,cQueryExpr)
ENDIF

lDCQUERY_QUICK_QUERY := .f.
IF !Empty(cQueryExpr)
  nSequence := nDCQUERY_PICKLOGICAL
ELSEIF !Empty(cField)
  nSequence := nDCQUERY_PICKOPERATOR
  cDCQUERY_FIELDDESC := cField
  cDCQUERY_FIELDTYPE := Type(cField)
  lDCQUERY_QUICK_QUERY := .t.
ELSE
  nSequence := nDCQUERY_PICKOPERATION
ENDIF

cDCQUERY_FIELDNAME := cField

IF Valtype(aFieldItems) # 'A'
  aFields := DC_FieldArray(.f.,,,,.t.)
  aFieldItems := aFields[2]
ELSE
  FOR i := 1 TO LEN(aFieldItems)
    IF Len(aFieldItems[i]) < 8
      ASize(aFieldItems[i],8)
    ENDIF
  NEXT
ENDIF

aDCQUERY_GETLIST := GetList


/* ----- Menu ----- */

DCMENUBAR oMenuBar OWNERDRAW

  DCSUBMENU oFileMenu PARENT oMenuBar PROMPT '&File'

    DCMENUITEM 'Save Query to Catalog' PARENT oFileMenu ;
      ACTION {||_DCQuerySave(cDCQUERY_QUERYEXPRESSION)} ;
      WHEN {||!Empty(cDCQUERY_QUERYEXPRESSION)}

    DCMENUITEM 'Test Query Expression' PARENT oFileMenu ;
      ACTION {||DC_GetRefresh(GetList), ;
                _dctestquery(cDCQUERY_QUERYEXPRESSION)} ;
      WHEN {||!Empty(cDCQUERY_QUERYEXPRESSION)}

    DCMENUITEM 'Exit' PARENT oFileMenu ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

/* ----- Query Catalog Window ----- */

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      OBJECT oQueryCatalogStatic ;
      HIDE {||nSequence <> nDCQUERY_PICKQUERY } ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT oQueryCatalogStatic

@ .5,2 DCSAY {||'Query Catalog for database ' + Alias() } ;
      FONT '10.Arial' COLOR GRA_CLR_BLUE ;
      SAYSIZE 50 ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y

@13,2 DCPUSHBUTTON CAPTION '&Back' SIZE 9,1.2 ;
      ACTION {||nSequence := nDCQUERY_PICKOPERATION, ;
                DC_GetRefresh(GetList) }

bQueryAction := ;
    {|| cDCQUERY_QUERYPICKEXPR := Alltrim(DCQUERY->query), ;
        nSequence := nDCQUERY_SELECTQUERY, ;
        QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@13,13 DCPUSHBUTTON CAPTION '&Next' SIZE 9,1.2 ;
       ACTION bQueryAction

@13,24 DCPUSHBUTTON CAPTION '&Delete' SIZE 9,1.2 ;
       ACTION {||nSequence := nDCQUERY_DELETEQUERY, ;
                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer), ;
                 nSequence := nDCQUERY_PICKQUERY}

@ 1.5,2 DCBROWSE oDCQUERY_BROW_QUERY ALIAS 'DCQUERY' SIZE 56,11 ;
      PRESENTATION DC_BrowPres() ;
      NOSOFTTRACK ;
      ID 'DCQUERY_BROWSE_CATALOG' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      DATALINK bQueryAction

DCSETPARENT oDCQUERY_BROW_QUERY

DCBROWSECOL FIELD DCQUERY->desc HEADER 'Description' WIDTH 10
DCBROWSECOL FIELD DCQUERY->query HEADER 'Query Expression' WIDTH 18
DCBROWSECOL FIELD DCQUERY->dbf_name HEADER 'Alias' WIDTH 10

/* ----- Logical Operator Window ----- */

DCSETPARENT TO

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      OBJECT oLogicalStatic ;
      HIDE {||nSequence <> nDCQUERY_PICKLOGICAL } ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT TO oLogicalStatic

@ 1,15 DCPUSHBUTTON CAPTION '.AND.' FONT '12.Alaska Crt' ;
       SIZE 30,1.5 ;
       TOOLTIP 'The next item added to the Query Expression will;' + ;
               'be logically ANDed with the current query' ;
       TABGROUP XBP_BEGIN_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oAndButton ;
       ACTION {|| cDCQUERY_ANDOR := ' .AND. ', ;
                  nSequence := nDCQUERY_PICKOPERATION, ;
                  DC_GetRefresh(GetList), ;
                  cDCQUERY_ANDOR_BUTTON := oAndButton, ;
                  QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 3,15 DCPUSHBUTTON CAPTION '.OR.' FONT '12.Alaska Crt' ;
       SIZE 30,1.5 ;
       TOOLTIP 'The next item added to the Query Expression will;' + ;
               'be logically ORed with the current query' ;
       TABGROUP XBP_WITHIN_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oOrButton ;
       ACTION {|| cDCQUERY_ANDOR := ' .OR. ', ;
                  IIF( !Empty(cDCQUERY_QUERYEXPRESSION), ;
                    cDCQUERY_QUERYEXPRESSION := '(' + cDCQUERY_QUERYEXPRESSION + ')',nil) , ;
                  IIF( !Empty(cDCQUERY_QUERYEXPRESSION), ;
                    AAdd(aDCQUERY_QUERYARRAY,cDCQUERY_QUERYEXPRESSION),nil), ;
                  nSequence := nDCQUERY_PICKOPERATION, ;
                  DC_GetRefresh(GetList), ;
                  cDCQUERY_ANDOR_BUTTON := oOrButton, ;
                  QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 5,15 DCPUSHBUTTON CAPTION '.AND. .NOT.' FONT '12.Alaska Crt' ;
       SIZE 30,1.5 ;
       TOOLTIP 'The next item added to the Query Expression will;' + ;
               'be logically ANDed with the current query and negated' ;
       TABGROUP XBP_WITHIN_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oAndNotButton ;
       ACTION {|| cDCQUERY_ANDOR := ' .AND. !', ;
                  nSequence := nDCQUERY_PICKOPERATION, ;
                  DC_GetRefresh(GetList), ;
                  cDCQUERY_ANDOR_BUTTON := oAndNotButton, ;
                  QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 7,15 DCPUSHBUTTON CAPTION '.OR. .NOT.' FONT '12.Alaska Crt' ;
       SIZE 30,1.5 ;
       TOOLTIP 'The next item added to the Query Expression will;' + ;
               'be logically ORed with the current query and negated' ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oOrNotButton ;
       TABGROUP XBP_WITHIN_GROUP ;
       ACTION {|| cDCQUERY_ANDOR := ' .OR. !', ;
                  IIF( !Empty(cDCQUERY_QUERYEXPRESSION), ;
                     cDCQUERY_QUERYEXPRESSION := '(' + cDCQUERY_QUERYEXPRESSION + ')',nil), ;
                  nSequence := nDCQUERY_PICKOPERATION, ;
                  DC_GetRefresh(GetList), ;
                  cDCQUERY_ANDOR_BUTTON := oOrNotButton, ;
                  QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 9,15 DCPUSHBUTTON CAPTION 'CLEAR QUERY' FONT '12.Alaska Crt' ;
       SIZE 30,1.5 ;
       TOOLTIP 'Clear the Query Expression and Start Over' ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       TABGROUP XBP_WITHIN_GROUP ;
       ACTION {|| cDCQUERY_ANDOR := '', ;
                  cDCQUERY_QUERYEXPRESSION := '', ;
                  nSequence := nDCQUERY_PICKOPERATION, ;
                  DC_GetRefresh(GetList), ;
                  QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@11,15 DCPUSHBUTTON CAPTION '&UNDO' FONT '12.Alaska Crt' ;
       SIZE 30,1.5 ;
       TOOLTIP 'Undo the last addition to the Query Expression' ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       TABGROUP XBP_WITHIN_GROUP ;
       ACTION {|| IIF( Len(aDCQUERY_QUERYARRAY) > 1, ;
                       ASize(aDCQUERY_QUERYARRAY,Len(aDCQUERY_QUERYARRAY)-1),nil), ;
                  IIF( Len(aDCQUERY_QUERYARRAY) == 1, ;
                       nSequence := nDCQUERY_PICKOPERATION,nil ), ;
                  IIF( Len(aDCQUERY_QUERYARRAY) == 1, ;
                       cDCQUERY_ANDOR := '',nil), ;
                  cDCQUERY_QUERYEXPRESSION := ATail(aDCQUERY_QUERYARRAY), ;
                  DC_GetRefresh(GetList) }

@13,15 DCPUSHBUTTON CAPTION 'DONE' FONT '12.Alaska Crt' ;
       SIZE 30,1.5 ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       TABGROUP XBP_END_GROUP ;
       ACTION {|| cDCQUERY_ANDOR := 'DONE', ;
                  DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

/* ----- Choose Type of Item Window (Field, Query, etc.) ----- */

DCSETPARENT TO

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      HIDE {||!(nSequence == nDCQUERY_PICKOPERATION) } ;
      OBJECT oOperationStatic ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT TO oOperationStatic

@ 1,15 DCPUSHBUTTON CAPTION '&Field Pick List' FONT '12.Alaska Crt' ;
       TOOLTIP 'Add a comparison value to the Query Expression by;' + ;
               'selecting a field and an operator from the database' ;
       SIZE 30,1.5 ;
       TABGROUP XBP_BEGIN_GROUP ;
       OBJECT oFieldButton ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       ACTION {||nSequence := nDCQUERY_PICKFIELD, ;
                 cDCQUERY_OPERATION_BUTTON := oFieldButton, ;
                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 3,15 DCPUSHBUTTON CAPTION '&Query Pick List' FONT '12.Alaska Crt' ;
       SIZE 30,1.5 ;
       TABGROUP XBP_WITHIN_GROUP ;
       TOOLTIP 'Add a comparison value to the Query Expression by;' + ;
               'selecting a saved query expression from the QUERY catalog' ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oQueryButton ;
       ACTION {||nSequence := nDCQUERY_PICKQUERY, ;
                 cDCQUERY_OPERATION_BUTTON := oQueryButton, ;
                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 5,15 DCPUSHBUTTON CAPTION '&Deleted' FONT '12.Alaska Crt' ;
       TOOLTIP 'Add the DELETED() function to the Query Expression;' + ;
               'to only select records that are Deleted or NOT Deleted' ;
       TABGROUP XBP_WITHIN_GROUP ;
       SIZE 30,1.5 ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oDeletedButton ;
       ACTION {||nSequence := nDCQUERY_PICKDELETED, ;
                 cDCQUERY_OPERATION_BUTTON := oDeletedButton, ;
                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 7,15 DCPUSHBUTTON CAPTION '&Tagged' FONT '12.Alaska Crt' ;
       TOOLTIP 'Add the DC_TAGGED() function to the Query Expression;' + ;
               'to only select records that are Tagged or NOT Tagged' ;
       SIZE 30,1.5 ;
       TABGROUP XBP_WITHIN_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oTaggedButton ;
       ACTION {||nSequence := nDCQUERY_PICKTAGGED, ;
                 cDCQUERY_OPERATION_BUTTON := oTaggedButton, ;
                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 9,15 DCPUSHBUTTON CAPTION '&Expression' FONT '12.Alaska Crt' ;
       SIZE 30,1.5 ;
       TABGROUP XBP_WITHIN_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       TOOLTIP 'Add an Expression to the current Query Expression' ;
       ACTION {||nSequence := nDCQUERY_PICKEXPRESSION, ;
                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@11,15 DCPUSHBUTTON CAPTION '&Back' FONT '12.Alaska Crt' ;
       SIZE 30,1.5 ;
       TABGROUP XBP_END_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       ACTION {||nSequence := nDCQUERY_PICKLOGICAL, ;
                 DC_GetRefresh(GetList)} ;
       WHEN {||!Empty(cDCQUERY_QUERYEXPRESSION)}


DCSETPARENT TO

/* ----- Choose Field Window ----- */

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      OBJECT oFieldsStatic ;
      HIDE {|| !(nSequence == nDCQUERY_PICKFIELD) } ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT TO oFieldsStatic

@ .5,2 DCSAY {||IIF( Empty(cDCQUERY_ANDOR),'Choose a Field', ;
                'Choose a Field to ' + cDCQUERY_ANDOR + ;
                ' to Query in Window' ) } ;
      FONT '10.Arial' COLOR GRA_CLR_BLUE ;
      SAYSIZE 50 ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y

@13,2 DCPUSHBUTTON CAPTION '&Back' SIZE 9,1.2 ;
      ACTION {||nSequence := nDCQUERY_PICKOPERATION, ;
                DC_GetRefresh(GetList) }

bFieldAction := ;
    {|| cDCQUERY_FIELDNAME := aFieldItems[nFieldPointer,DCFLD_NAME], ;
        cDCQUERY_FIELDDESC := aFieldItems[nFieldPointer,DCFLD_DESC], ;
        cDCQUERY_FIELDTYPE := aFieldItems[nFieldPointer,DCFLD_TYPE], ;
        nDCQUERY_FIELDLEN := aFieldItems[nFieldPointer,DCFLD_LEN], ;
        nSequence := nDCQUERY_PICKOPERATOR, ;
        _FilterOperatorArray( aOperators, cDCQUERY_FIELDTYPE ), ;
        DC_GetRefresh(GetList), ;
        QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@13,13 DCPUSHBUTTON CAPTION '&Next' SIZE 9,1.2 ;
       ACTION bFieldAction

@ 1.5,2 DCBROWSE oDCQUERY_BROW_FIELDS DATA aFieldItems SIZE 56,11 ;
      PRESENTATION DC_BrowPres() ;
      POINTER nFieldPointer ;
      NOSOFTTRACK ;
      NOHSCROLL ;
      ;// FIT ;
      ID 'DCQUERY_BROWSE_FIELDITEMS' ;
      DATALINK bFieldAction ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT TO oDCQUERY_BROW_FIELDS
DCBROWSECOL ELEMENT DCFLD_DESC WIDTH 15 HEADER 'Field Description'
DCBROWSECOL ELEMENT DCFLD_NAME WIDTH 7 HEADER 'Field Name'
DCBROWSECOL ELEMENT DCFLD_TYPE WIDTH 3 HEADER 'Type'
DCBROWSECOL ELEMENT DCFLD_LEN WIDTH 3 HEADER 'Len'
DCBROWSECOL ELEMENT DCFLD_DEC WIDTH 3 HEADER 'Dec'

DCSETPARENT TO

/* ----- Choose Operator Window ----- */

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      OBJECT oOperatorStatic ;
      HIDE {||nSequence # nDCQUERY_PICKOPERATOR} ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

aOperators := _OperatorArray()

DCSETPARENT TO oOperatorStatic

@ .5,2 DCSAY {||'Choose an Operator for ' + Upper(Alltrim(cDCQUERY_FIELDDESC))};
       FONT '10.Arial' COLOR GRA_CLR_BLUE ;
       SAYSIZE 50 ;
       RESIZE DCGUI_RESIZE_REPOSONLY_Y

@13,2 DCPUSHBUTTON CAPTION '&Back' SIZE 9,1.2 ;
      ACTION {||nSequence := nDCQUERY_PICKFIELD, ;
                DC_GetRefresh(GetList), ;
                SetAppFocus(oDCQUERY_BROW_FIELDS) }

nOperatorPointer := 1
bOperatorAction := ;
      {|| cDCQUERY_OPERATOR := aOperators[nOperatorPointer,2], ;
          nSequence := nDCQUERY_PICKVALUE, ;
          DC_GetRefresh(GetList), ;
          QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@13,13 DCPUSHBUTTON CAPTION '&Next' SIZE 9,1.2 ;
       ACTION bOperatorAction

@ 1.5,2 DCBROWSE oDCQUERY_BROW_OPERATORS DATA aOperators SIZE 55,11 ;
      PRESENTATION DC_BrowPres() ;
      FONT '10.Courier New' ;
      NOHSCROLL ;
      NOSOFTTRACK ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      POINTER nOperatorPointer ;
      ITEMSELECTED bOperatorAction

DCSETPARENT TO oDCQUERY_BROW_OPERATORS
DCBROWSECOL ELEMENT 1 WIDTH 50 HEADER 'Operator'

/* ----- Enter a Value Window ----- */

DCSETPARENT TO
@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      OBJECT oDCQUERY_VALUESTATIC ;
      HIDE {||!(nSequence == nDCQUERY_PICKVALUE) } ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT TO


/* ----- Query Expression Window ----- */

@15,0 DCSAY 'Query Condition:' SAYSIZE 0 FONT '10.Arial' ;
      COLOR GRA_CLR_BLUE

@16,0 DCMULTILINE cDCQUERY_QUERYEXPRESSION SIZE 49,4 ;
      OBJECT oDCQUERY_MEMOOBJECT ;
      NOHORIZSCROLL ;
      FONT '8.Alaska Crt' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY_X

@16,51 DCPUSHBUTTON CAPTION '&Ok' SIZE 9,1.2  ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      WHEN {||!Empty(cDCQUERY_QUERYEXPRESSION)} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_X

@18,51 DCPUSHBUTTON CAPTION '&Cancel' SIZE 9,1.2  ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,aDCQUERY_GETLIST2), ;
                DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_X

DCGETOPTIONS ABORTQUERY ;
             CLOSEQUERY ;
             HILITEGETS GRA_CLR_RED ;
             TABSTOP ;
             RESIZE

DCREAD GUI ;
   ;// EXPRESS ;
   FIT ;
   MODAL ;
   TO lOk ;
   TITLE 'Query Builder Wizard' ;
   SETAPPWINDOW ;
   OPTIONS GetOptions ;
   EVAL {|o|cDCQUERY_ANDOR_BUTTON := oAndButton, ;
            cDCQUERY_OPERATION_BUTTON := oFieldButton, ;
            SetAppFocus(IIF(!Empty(cField),oDCQUERY_BROW_OPERATORS:getColumn(1),oFieldButton)) }

/* if after all that the cQueryExpr is empty, restore the old query */
IF EMPTY(ALLTRIM(cDCQUERY_QUERYEXPRESSION))
  cDCQUERY_QUERYEXPRESSION  :=  cOldQuery
ENDIF
DC_ClearEvents()

RETURN cDCQUERY_QUERYEXPRESSION

* ----------------------

STATIC FUNCTION QuerySequence( nSequence, aQueryBuild, aFieldItems, nFieldPointer )

LOCAL cOldQuery, cQueryExpr, cCompareTo, GetList := {}, lOk, cFieldType, ;
      cOperator, cNewQuery, cExpression, cOperation, xValue1, xValue2, ;
      nChoice, nSaveRec, cFieldName, cAndOr, cHoldQuery, aList, oXbp, i, ;
      cFieldDesc, nFieldLen, lCaseSensitive, oValue1, GetOptions, ;
      lExpression

cQueryExpr := cDCQUERY_QUERYEXPRESSION
cAndOr     := cDCQUERY_ANDOR
cOperator  := cDCQUERY_OPERATOR
cOperation := cDCQUERY_OPERATION
cFieldName := cDCQUERY_FIELDNAME
cFieldType := cDCQUERY_FIELDTYPE
cFieldDesc := cDCQUERY_FIELDDESC
nFieldLen  := nDCQUERY_FIELDLEN
lCaseSensitive := .f.
lOk := .t.
lExpression := .f.

aDCQUERY_GETLIST2 := GetList
cOldQuery := cQueryExpr

IF nSequence == nDCQUERY_PICKFIELD

  SetAppFocus(oDCQUERY_BROW_FIELDS)

ELSEIF nSequence == nDCQUERY_PICKOPERATOR

  SetAppFocus(oDCQUERY_BROW_OPERATORS:getColumn(1))

ELSEIF nSequence == nDCQUERY_PICKOPERATION

  SetAppFocus(cDCQUERY_OPERATION_BUTTON)

ELSEIF nSequence == nDCQUERY_PICKTAGGED

  cQueryExpr += cAndOr + ;
      IIF(TYPE('FIELD->TAG')='L','TAG','DC_TAGGED()')
  nSequence := nDCQUERY_PICKLOGICAL

ELSEIF nSequence == nDCQUERY_PICKQUERY

  cDCQUERY_QUERYPICKEXPR := ''

ELSEIF nSequence == nDCQUERY_DELETEQUERY

  IF DC_MsgBox(,,{'Delete QUERY?: ' + DCQUERY->desc},,,,.t.)
    IF DCQUERY->(DC_RecLock(5))
      DCQUERY->(dbDelete())
      oDCQUERY_BROW_QUERY:refreshAll()
      DCQUERY->(dbUnlock())
    ENDIF
  ENDIF

ELSEIF nSequence == nDCQUERY_SELECTQUERY

  IF !Empty(cDCQUERY_QUERYPICKEXPR)
    cQueryExpr += cAndOr + cDCQUERY_QUERYPICKEXPR
    nSequence := nDCQUERY_PICKLOGICAL
  ELSE
    nSequence := nDCQUERY_PICKOPERATION
    SetAppFocus(cDCQUERY_OPERATION_BUTTON)
  ENDIF

ELSEIF nSequence == nDCQUERY_PICKDELETED

  cQueryExpr += cAndOr + 'DELETED()'
  nSequence := nDCQUERY_PICKLOGICAL

ELSEIF nSequence == nDCQUERY_PICKEXPRESSION

  nSequence := nDCQUERY_PICKVALUE
  DC_GetRefresh(aDCQUERY_GETLIST)

  @13,2 DCPUSHBUTTON CAPTION '&Back' SIZE 9,1.2 ;
        ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList) } ;
        ACCELKEY xbeK_ALT_B

  @13,13 DCPUSHBUTTON CAPTION '&Next' SIZE 9,1.2 ;
        ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) } ;
        ACCELKEY xbeK_ALT_N

  cExpression := Space(200)
  @ 2,5 DCSAY 'Enter Expression'
  @ 3,5 DCMULTILINE cExpression SIZE 40,5 ;
        NOHORIZSCROLL FONT '10.Courier' ;
        RESIZE DCGUI_RESIZE_RESIZEONLY_X

  DCREAD GUI ;
     EXPRESS ;
     TO lOk ;
     SAVE ;
     PARENT oDCQUERY_VALUESTATIC
  DC_GetDestroy(GetList)
  IF lOk
    cQueryExpr += cAndOr + ALLTRIM(Strtran(cExpression,Chr(13)+Chr(10),''))
    nSequence := nDCQUERY_PICKLOGICAL
  ELSE
    nSequence := nDCQUERY_PICKOPERATION
    SetAppFocus(cDCQUERY_OPERATION_BUTTON)
  ENDIF

ELSEIF nSequence == nDCQUERY_PICKVALUE

  BEGIN SEQUENCE

  cOperation := ''
  // get operator message
  cOperator := Alltrim(cOperator)
  DO CASE
        CASE cOperator=='=='
           cOperation := DCQMSG_56_10
        CASE cOperator=='='
           cOperation := DCQMSG_56_1
        CASE cOperator=='<>'
           cOperation := DCQMSG_56_2
        CASE cOperator=='<='
           cOperation := DCQMSG_56_3
        CASE cOperator=='>='
           cOperation := DCQMSG_56_4
        CASE cOperator=='<'
           cOperation := DCQMSG_56_5
        CASE cOperator=='>'
           cOperation := DCQMSG_56_6
        CASE cOperator=='$'
           cOperation := DCQMSG_56_7
        CASE cOperator=='!$'
           cOperation := DCQMSG_56_8
        CASE cOperator=='SL'
           cOperation := DCQMSG_56_9
        CASE cOperator=='END'
           cOperation := DCQMSG_56_11
        CASE cOperator=='RAN'
           cOperation := DCQMSG_56_12
  ENDCASE

  //- get the comparison value now
  cCompareTo := ''

  DCGETOPTIONS TABSTOP HILITEGETS GRA_CLR_RED

  IF cFieldType $ 'CDNMCXMX' .AND. !(cOperator == 'EM') .AND. !(cOperator == '!EM')

    DCSETPARENT oDCQUERY_VALUESTATIC

    IF cFieldType $ 'CMCXMX'
      @ 11.5, 2 DCCHECKBOX lCaseSensitive PROMPT 'Match is Case Sensitive'
    ENDIF

    @13.2,2 DCPUSHBUTTON CAPTION '&Back' SIZE 10,1.2 ;
            TOOLTIP 'Go Back and select a different field' ;
            ACTION {||nSequence := nDCQUERY_PICKOPERATOR, ;
                    DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList) }

    @13.2,14 DCPUSHBUTTON CAPTION '&Next' SIZE 10,1.2 ;
             TOOLTIP 'Accept the entered value(s)' ;
             ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

    @13.2,26 DCPUSHBUTTON CAPTION 'Bro&wse' SIZE 10,1.2 ;
             TOOLTIP 'Browse values in database for this field' ;
             ACTION {||_PickBrowse( cFieldName, cFieldDesc, cFieldType, ;
                                    nFieldLen, @xValue1, @xValue2, ;
                                    @cCompareTo, GetList )}

    @13.2,38 DCPUSHBUTTON CAPTION '&Expression' SIZE 10,1.2 ;
             TOOLTIP 'Enter an Expression as the Value to Compare' ;
             ACTION {||lExpression := _DCQueryEx(@cCompareTo), ;
                       DC_GetRefresh(GetList), ;
                       IIF( lExpression,DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList),nil) }

  ENDIF

  IF cOperator == 'EM'  //Empty
     IF 'X' $ cFieldType
       cCompareTo := ''
     ELSE
       cCompareTo  :=  'EMPTY('+cFieldName+')'
     ENDIF

  ELSEIF cOperator == '!EM' // Not Empty
     IF 'X' $ cFieldType
       cCompareTo := ''
     ELSE
       cCompareTo  :=  '!EMPTY('+cFieldName+')'
     ENDIF

  ELSEIF cFieldType = "C"

    IF cOperator='R'

      STORE SPACE(30) TO xValue1, xValue2
      @ 2,5 DCSAY DCQMSG_60 + Alltrim(Upper(cFieldDesc)) SAYSIZE 0
      // 'Starting range '
      @ 3,5 DCSAY DCQMSG_58 GET xValue1 VALID {||DC_ReadEmpty(xValue1)} ;
            GETOBJECT oValue1 PICTURE aFieldItems[nFieldPointer,8]
      // 'Ending range   '
      @ 4,5 DCSAY DCQMSG_59 GET xValue2 VALID {||DC_ReadEmpty(xValue2)} ;
             PICTURE aFieldItems[nFieldPointer,8]

      DC_ClearEvents()
      DCREAD GUI ;
         EXPRESS ;
         OPTIONS GetOptions ;
         TO lOk ;
         CLEAREVENTS ;
         SAVE ;
         PARENT oDCQUERY_VALUESTATIC ;
         ENTEREXIT ;
         SETFOCUS @oValue1

      DC_GetDestroy(GetList)

      IF !lOk
      ELSEIF !EMPTY(cCompareTo) .AND. LEFT(cCompareTo,1)=CHR(255)
        cCompareTo := ALLTRIM(SUBSTR(cCompareTo,2))
      ELSEIF lCaseSensitive
        cCompareTo  := ;
               'DC_Range(' + cFieldName + ',"' + ;
                AllTrim(xValue1)+'","' + ;
                AllTrim(xValue2)+'")'
      ELSE
        cCompareTo  := ;
               'DC_Range(' + cFieldName + ',"' + ;
                AllTrim(Upper(xValue1)) + '","' + ;
                AllTrim(Upper(xValue2)) + '")'
      ENDIF

    ELSE

      cCompareTo  :=  SPACE(MIN(LEN(&(Strtran(cFieldName,'[]','.T.'))),40))
      @ 3,5 DCSAY DCQMSG_60 + Upper(Alltrim(cFieldDesc)) FONT '10.Arial' SAYSIZE 0
      @ 4,5 DCSAY cOperation FONT '10.Arial' SAYSIZE 0
      @ 5,5 DCGET cCompareTo OBJECT oValue1 PICTURE aFieldItems[nFieldPointer,8]

      DC_ClearEvents()

      DCREAD GUI ;
         EXPRESS ;
         OPTIONS GetOptions ;
         TO lOk ;
         CLEAREVENTS ;
         SAVE ;
         PARENT oDCQUERY_VALUESTATIC ;
         ENTEREXIT ;
         SETFOCUS @oValue1

      DC_GetDestroy(GetList)

      IF !lOk
      ELSEIF !EMPTY(cCompareTo) .AND. LEFT(cCompareTo,1)=CHR(255)
        cCompareTo := ALLTRIM(SUBSTR(cCompareTo,2))
      ELSE
        //- if its empty, use the EMPTY() function to compare it
        IF EMPTY(cCompareTo) .AND. cOperator = '='
          cCompareTo  :=  'EMPTY('+cFieldName+')'
        ELSEIF EMPTY(cCompareTo) .AND. cOperator  = '<>'
          cCompareTo  :=  '!EMPTY('+cFieldName+')'
        ELSEIF lCaseSensitive
          cCompareTo  :=  ALLTRIM(cCompareTo)
          cCompareTo  :=  '"'+cCompareTo+'"'
        ELSE
          cCompareTo  :=  ALLTRIM(Upper(cCompareTo))
          cCompareTo  :=  '"'+cCompareTo+'"'
        ENDIF
      ENDIF

    ENDIF

  ELSEIF cFieldType = "N"

    IF cOperator == 'RAN'

       nSaveRec := RecNo()
       GO BOTT
       SKIP
       STORE &cFieldName TO xValue1,xValue2
       GO nSaveRec
       @ 2,12 DCSAY DCQMSG_61 + Alltrim(Upper(cFieldDesc)) SAYSIZE 0
       /* Starting range */
       @ 3,12 DCSAY DCQMSG_58 GET xValue1 GETOBJECT oValue1 PICTURE aFieldItems[nFieldPointer,8]
       /* Ending range */
       @ 4,12 DCSAY DCQMSG_59 GET xValue2 PICTURE aFieldItems[nFieldPointer,8]

       DC_ClearEvents()

       DCREAD GUI ;
         EXPRESS ;
         OPTIONS GetOptions ;
         TO lOk ;
         SAVE ;
         PARENT oDCQUERY_VALUESTATIC ;
         ENTEREXIT ;
         SETFOCUS @oValue1

       DC_GetDestroy(GetList)
       IF !EMPTY(cCompareTo) .AND. LEFT(cCompareTo,1)=CHR(255)
         cCompareTo := ALLTRIM(SUBSTR(cCompareTo,2))
       ELSE
         cCompareTo := 'DC_RANGE(' + cFieldName+','+;
                    ALLTRIM(TRANSFORM(xValue1,""))+','+;
                    ALLTRIM(TRANSFORM(xValue2,""))+')'
       ENDIF

     ELSE

       /* start with 0 */
       nSaveRec := RecNo()
       GO BOTT
       SKIP

       xValue1  :=  &(Strtran(cFieldName,'[]','.T.'))
       GO nSaveRec
       @ 3,5 DCSAY DCQMSG_61 + Upper(Alltrim(cFieldDesc)) FONT '10.Arial' SAYSIZE 0
       @ 4,5 DCSAY cOperation FONT '10.Arial' SAYSIZE 0

*qqq tu som skal upravi rozmer polka, tu problm, e niekde zadefinovan chybne rka o 1 menej napr. pri ICO
* aj ke zmenm rku poa , dovol zapsa iba pvodn poet sel, teda mus by definovan v oValue1
* povodne
      @ 5,5 DCGET xValue1 OBJECT oValue1 

       DC_ClearEvents()

       DCREAD GUI ;
         EXPRESS ;
         OPTIONS GetOptions ;
         TO lOk ;
         SAVE ;
         PARENT oDCQUERY_VALUESTATIC ;
         ENTEREXIT ;
         SETFOCUS @oValue1

       DC_GetDestroy(GetList)

*qqq kontroln ukka ak hodnotu zobral, tu vidno, e u tu je to zaokrhlen  berie dobre iba cislo zacinajuce na 1
*    napr. 1234567890 ok, ale 2234567890 u zle
*ladenie(xValue1)

       IF LEFT(cCompareTo,1)=CHR(255)
         cCompareTo := ALLTRIM(SUBSTR(cCompareTo,2))
       ELSE
         cCompareTo := ALLTRIM(TRANSFORM(xValue1,""))
       ENDIF

     ENDIF

   ELSEIF cFieldType = "D"

     IF cOperator == 'RAN'

       STORE CTOD('  /  /    ') TO xValue1,xValue2
       @ 2,12 DCSAY DCQMSG_62 + Alltrim(Upper(cFieldDesc)) SAYSIZE 0
       /* Starting range */
       @ 3,12 DCSAY DCQMSG_58 GET xValue1 POPUP {|d|DC_PopDate(d,,,,,,2)} ;
              SAYSIZE 15 SAYRIGHT GETOBJECT oValue1
       /* Ending range */
       @ 4,12 DCSAY DCQMSG_59 GET xValue2 POPUP {|d|DC_PopDate(d,,,,,,2)} ;
              SAYSIZE 15 SAYRIGHT
       /* (Date) */

       DC_ClearEvents()

       DCREAD GUI ;
         EXPRESS ;
         OPTIONS GetOptions ;
         TO lOk ;
         SAVE ;
         PARENT oDCQUERY_VALUESTATIC ;
         ENTEREXIT ;
         SETFOCUS oValue1

       DC_GetDestroy(GetList)
       IF !EMPTY(cCompareTo) .AND. LEFT(cCompareTo,1)=CHR(255)
         cCompareTo := ALLTRIM(SUBSTR(cCompareTo,2))
       ELSE
         cCompareTo := ;
           'DC_RANGE(' + cFieldName+',CTOD("'+DTOC(xValue1)+'"),'+;
           'CTOD("'+DTOC(xValue2)+'"))'
       ENDIF

     ELSEIF cOperator == 'YR'

       xValue1 := YEAR(DATE())
       /* Enter Year */
       @ 3,12 DCSAY DCQMSG_14  GET xValue1 PICT '9999'

       DC_ClearEvents()

       DCREAD GUI ;
         EXPRESS ;
         TO lOk ;
         SAVE ;
         PARENT oDCQUERY_VALUESTATIC ;
         ENTEREXIT ;
         OPTIONS GetOptions

       DC_GetDestroy(GetList)
       cCompareTo := 'YEAR('+cFieldName+')='+STR(xValue1,4)

     ELSEIF cOperator == 'TOD'
       cCompareTo  :=  cFieldName+'=DATE()'

     ELSEIF cOperator == 'MON'

       xValue1 := Alltrim(Str(Month(Date()))) + ' = ' + CMonth(Date())
       aList := DC_CMonthArray()
       FOR i := 1 TO Len(aList)
         aList[i] := Str(i,2) + ' = ' + aList[i]
       NEXT
       @ 2,12 DCSAY DCQMSG_15
       @ 3,12 DCLISTBOX xValue1 LIST aList SIZE 20,8 ;
              FONT '10.Courier' ;
              EVAL {|o|o:itemSelected := {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}}

       DC_ClearEvents()

       DCREAD GUI ;
         EXPRESS ;
         TO lOk ;
         SAVE ;
         PARENT oDCQUERY_VALUESTATIC ;
         OPTIONS GetOptions

       xValue1 := Val(SubStr(xValue1,1,2))
       DC_GetDestroy(GetList)
       cCompareTo  :=  'MONTH('+cFieldName+')='+STR(xValue1,2)

     ELSEIF cOperator == 'DAY' /* Enter Day of Month (1-31) */

       xValue1 := DAY(DATE())
       @ 3,12 DCSAY DCQMSG_16 GET xValue1 RANGE 1,31 ;
              SAYRIGHT SAYSIZE 0
       DC_ClearEvents()

       DCREAD GUI EXPRESS TO lOk SAVE PARENT oDCQUERY_VALUESTATIC ENTEREXIT
       DC_GetDestroy(GetList)
       cCompareTo  :=  'DAY('+cFieldName+')='+STR(xValue1,2)

     ELSEIF cOperator == 'DOW'   /* Enter Day of Week menu (1-7) */

       xValue1 := Alltrim(Str(Dow(Date()))) + ' = ' + CDow(Date())
       aList := DC_CDowArray()
       FOR i := 1 TO Len(aList)
         aList[i] := Alltrim(Str(i)) + ' = ' + aList[i]
       NEXT
       @ 2,12 DCSAY DCQMSG_17
       @ 3,12 DCLISTBOX xValue1 LIST aList SIZE 20,5 ;
              FONT '10.Courier' ;
              OBJECT oXbp ;
              EVAL {|o|o:itemSelected:={||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}}

      DC_ClearEvents()

      DCREAD GUI ;
         EXPRESS ;
         TO lOk ;
         SAVE ;
         PARENT oDCQUERY_VALUESTATIC ;
         SETFOCUS @oXbp ;
         OPTIONS GetOptions

       xValue1 := Val(SubStr(xValue1,1,1))
       DC_GetDestroy(GetList)
       cCompareTo  :=  'DOW('+cFieldName+')='+STR(xValue1,1)

     ELSE

       xValue1  := CTOD('  /  /  ')
       @ 3,5 DCSAY DCQMSG_62 + Upper(Alltrim(cFieldDesc)) FONT '10.Arial' SAYSIZE 0
       @ 4,5 DCSAY cOperation FONT '10.Arial' SAYSIZE 0
       @ 5,5 DCGET xValue1 POPUP {|d|DC_PopDate(d,,,,,,2)}

      DC_ClearEvents()

      DCREAD GUI ;
         EXPRESS ;
         TO lOk ;
         SAVE ;
         PARENT oDCQUERY_VALUESTATIC ;
         ENTEREXIT ;
         OPTIONS GetOptions

       DC_GetDestroy(GetList)
       IF !EMPTY(cCompareTo) .AND. LEFT(cCompareTo,1)=CHR(255)
         cCompareTo := SUBSTR(cCompareTo,2)
       ELSE
         cCompareTo := DTOC(xValue1)
         cCompareTo := 'CTOD("'+cCompareTo+'")'
       ENDIF

     ENDIF

  ELSEIF cFieldType = "L"    //- logical

    IF cOperator == '.T.'
      cCompareTo :=  cFieldName
    ELSE
      cCompareTo := '!' + cFieldName
    ENDIF

  ELSEIF cFieldType='M'

    cCompareTo := SPACE(30)
    /* Memo contains */
    @ 3,5 DCSAY DCQMSG_20 + Upper(Alltrim(cFieldDesc)) FONT '10.Arial' SAYSIZE 0
    @ 4,5 DCSAY cOperation FONT '10.Arial' SAYSIZE 0
    @ 5,5 DCGET cCompareTo

    DC_ClearEvents()

    DCREAD GUI ;
      EXPRESS ;
      TO lOk ;
      SAVE ;
      PARENT oDCQUERY_VALUESTATIC ;
      ENTEREXIT ;
      OPTIONS GetOptions

    DC_GetDestroy(GetList)
    IF lCaseSensitive
      cCompareTo := ALLTRIM(cCompareTo)
      cCompareTo := '"'+cCompareTo+'"'
    ELSE
      cCompareTo := ALLTRIM(Upper(cCompareTo))
      cCompareTo := '"'+cCompareTo+'"'
    ENDIF

  ENDIF

  nSequence := nDCQUERY_PICKLOGICAL

  IF lDCQUERY_QUICK_QUERY
    DC_ReadGuiEvent(DCGUI_EXIT_OK,aDCQUERY_GETLIST)
  ENDIF

  IF !lOk
    nSequence := nDCQUERY_PICKOPERATOR
    DC_GetRefresh(aDCQUERY_GETLIST)
    SetAppFocus(oDCQUERY_BROW_FIELDS)
  ENDIF

  IF !(nSequence == nDCQUERY_PICKLOGICAL)
    BREAK
  ELSE
    DC_GetRefresh(aDCQUERY_GETLIST)
    SetAppFocus(cDCQUERY_ANDOR_BUTTON)
  ENDIF

  /* store the query to a temp variable */
  cHoldQuery  :=  cQueryExpr

  /* here we finish building this portion of the query string */
  IF cFieldType$'CMCMCX'

    IF !lCaseSensitive
      cCompareTo := Upper(cCompareTo)
    ENDIF

    IF 'X' $ cFieldType

      cFieldName := Strtran(cFieldName,'[x]',cCompareTo)
      cFieldName := Strtran(cFieldName,'[=]','"' + cOperator + '"')
      cQueryExpr += cAndOr + cFieldName

    ELSEIF cOperator == '=='

      IF lCaseSensitive
        cFieldName := 'Trim('+cFieldName+')'
      ELSE
        cFieldName := 'Trim(Upper('+cFieldName+'))'
      ENDIF

      cQueryExpr += cAndOr + cFieldName + '==' + cCompareTo

    ELSEIF cOperator == "$"

       /* if comparing substring */
       IF lCaseSensitive
         cQueryExpr += cAndOr + cCompareTo + '$' + cFieldName
       ELSE
         cQueryExpr += cAndOr + cCompareTo + '$Upper(' + cFieldName + ')'
       ENDIF

    ELSEIF cOperator == "!$"

       /* if comparing substring */
       IF lCaseSensitive
         cQueryExpr += cAndOr + '!' + cCompareTo + '$' + cFieldName
       ELSE
         cQueryExpr += cAndOr + '!' + cCompareTo + '$Upper(' + cFieldName + ')'
       ENDIF

    ELSEIF cOperator == "SL"

      /* if comparing SIMILIAR SOUNDING */
      cQueryExpr += cAndOr + ;
        'DC_Like('+cFieldName+','+cCompareTo+')'

    ELSEIF cOperator == "END"

      /* if comparing ENDS WITH */
      IF lCaseSensitive
        cQueryExpr += cAndOr + ;
          'DC_EndsWith('+cFieldName+','+cCompareTo+')'
      ELSE
        cQueryExpr += cAndOr + ;
          'DC_EndsWith(Upper('+cFieldName+'),'+cCompareTo+')'
      ENDIF

    ELSEIF cOperator == 'R' .OR. cOperator == 'RAN' .OR. Upper(Left(cCompareTo,5))='EMPTY';
           .OR. Upper(Left(cCompareTo,6))='!EMPTY'

      cQueryExpr += cAndOr+cCompareTo

    ELSE

      /* otherwise, must just be a string */
      IF lCaseSensitive
        cQueryExpr += cAndOr + cFieldName + cOperator + cCompareTo
      ELSE
        cQueryExpr += cAndOr + 'Upper(' + cFieldName + ')' + cOperator + cCompareTo
      ENDIF

    ENDIF

  ELSEIF cFieldType $ "ND"   //- numeric/date field type

    IF cOperator == 'RAN' .OR. Upper(Left(cCompareTo,5))='EMPTY';
         .OR. Upper(Left(cCompareTo,6))='!EMPTY' .OR. ;
         ' ' + cOperator + ' ' $ ' MON DAY DOW YR TOD '
      cQueryExpr += cAndOr+cCompareTo
    ELSE
      cQueryExpr += cAndOr+cFieldName+cOperator+cCompareTo
    ENDIF

  ELSEIF cFieldType = "L"   //- logical field type

    cQueryExpr += cAndOr + IIF(cOperator='!','!','') + cCompareTo

  ENDIF

  /* check for line-length boundary */
  IF LEN(cQueryExpr) > 1000
    GetList := {}
    /* if its too long, restore old query string */
    cQueryExpr :=  cHoldQuery
    /* display error message */
    @ 11,12 DCSAY DCQMSG_21_1
    @ 12,12 DCSAY cDCQUERY_QUERYNAME
    @ 13,12 DCSAY DCQMSG_21_3
    @ 15,12 DCSAY DCQMSG_21_4
    DCREAD GUI EXPRESS FIT BUTTONS DCGUI_BUTTON_OK MODAL
  ENDIF

  END SEQUENCE

ENDIF

IF !(cDCQUERY_QUERYEXPRESSION == cQueryExpr)
  cDCQUERY_QUERYEXPRESSION := cQueryExpr
  AAdd(aDCQUERY_QUERYARRAY,cQueryExpr)
ENDIF

cDCQUERY_ANDOR := cAndOr
cDCQUERY_OPERATOR := cOperator
cDCQUERY_OPERATION := cOperation
cDCQUERY_FIELDNAME := cFieldName
cDCQUERY_FIELDTYPE := cFieldType

DC_GetRefresh(aDCQUERY_GETLIST)

RETURN nSequence

* ---------------------

STATIC FUNCTION _OperatorArray()

RETURN { { DCQMSG_44_1,  '=  ' }, ;
         { DCQMSG_44_2,  '== ' }, ;
         { DCQMSG_44_3,  '<> ' }, ;
         { DCQMSG_44_4,  '<  ' }, ;
         { DCQMSG_44_5,  '>  ' }, ;
         { DCQMSG_44_6,  '<= ' }, ;
         { DCQMSG_44_7,  '>= ' }, ;
         { DCQMSG_44_8,  'EM ' }, ;
         { DCQMSG_44_9,  '!EM' }, ;
         { DCQMSG_44_10, 'SL ' }, ;
         { DCQMSG_44_11, 'END' }, ;
         { DCQMSG_44_12, '$  ' }, ;
         { DCQMSG_44_13, '!$ ' }, ;
         { DCQMSG_44_14, '.F.' }, ;
         { DCQMSG_44_15, '.T.' }, ;
         { DCQMSG_44_16, 'RAN' }, ;
         { DCQMSG_44_17, 'DOW' }, ;
         { DCQMSG_44_18, 'DAY' }, ;
         { DCQMSG_44_19, 'MON' }, ;
         { DCQMSG_44_20, 'YR ' }, ;
         { DCQMSG_44_21, 'TOD' } }

* --------------------

STATIC FUNCTION _FilterOperatorArray( aArray, cFieldType )

LOCAL i, aOperator := _OperatorArray()

ASize(aArray,0)

FOR i := 1 TO Len(aOperator)
  IF i >= 1 .AND. i <= 9 .AND. cFieldType $ 'CNMDCXMX'
    AAdd( aArray, aOperator[i] )
  ELSEIF i >= 10 .AND. i <= 13 .AND. cFieldType $ 'CMCXMX'
    AAdd( aArray, aOperator[i] )
  ELSEIF i >= 14 .AND. i <= 15 .AND. cFieldType = 'L'
    AAdd( aArray, aOperator[i] )
  ELSEIF i == 16 .AND. cFieldType $ 'CNMDCXMX'
    AAdd( aArray, aOperator[i] )
  ELSEIF i > 16 .AND. cFieldType = 'D'
    AAdd( aArray, aOperator[i] )
  ENDIF
NEXT

RETURN nil

* ----------------

STATIC FUNCTION _PickBrowse( cFieldName, cFieldDesc, cFieldType, nFieldLen, ;
                             xValue1, xValue2, cCompareTo, aGetList )

LOCAL  GetList := {}, nSaveRec, cFilter, oBrowse, lOk, ;
       bData, cAlias := Alias()

cFilter := DBFILTER()
nSaveRec := RECNO()
IF cFieldType='M'
  RETURN nil
ENDIF

SET FILT TO !EMPTY(&(cFieldName))
GO TOP
@ 0,0 DCBROWSE oBrowse ALIAS cAlias SIZE 50,15 ;
      PRESENTATION DC_BrowPres() ;
      DATALINK {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      FIT ;
      FONT '8.Courier New'

bData := &('{||' + cAlias + '->' + cFieldName + '}')

DCBROWSECOL DATA bData HEADER cFieldDesc WIDTH nFieldLen PARENT oBrowse
@ 0,30 DCSAY ''

DCREAD GUI EXPRESS FIT ADDBUTTONS MODAL TO lOk TITLE DCQMSG_39_1 MODAL

IF lOk
  IF Valtype(xValue1) = 'U' .AND. Valtype(xValue2) = 'U'
    cCompareTo := &cFieldName
  ELSE
    xValue1 := &cFieldName
    xValue2 := xValue1
  ENDIF
  DC_GetRefresh(aGetList)
ENDIF

IF !EMPTY(cFilter)
  SET FILTER TO &cFilter
ELSE
  SET FILTER TO
ENDIF
GO nSaveRec

RETURN ''

* ---------------------

FUNCTION DC_Query()
RETURN DC_QueryBuild()

/* ---------------- */

STATIC FUNCTION _DCQueryOpen( cAlias )

LOCAL cSetDclip, nSaveArea := Select(), cFilter, bFilter
LOCAL aStructure := ;
       { {'DBF_NAME','C',8,0},;
         {'DESC','C',40,0},;
         {'USR_ID','C',8,0},;
         {'QUERY','M',10,0} }

DEFAULT cAlias := Alias()
/* A Database must be open to use this function */
IF EMPTY(ALIAS())
  DC_WinAlert(DCQMSG_41)
  RETURN .f.
ENDIF

IF !DC_DBSEL( 'DCQUERY' )
  DC_DbSel('0')
  IF !DC_DBFILE( DC_SetDclip(),'DCQUERY', .t.,,,DC_DictRdd(),,aStructure)
    SELE (nSaveArea)
    RETURN .f.
  ENDIF
ENDIF

cFilter := 'DBF_NAME="' + cAlias + '"'

/*
IF !EMPTY(PAD(DC_UserInfo(1),8))
  cFilter := 'DBF_NAME="' + cAlias + '" .AND.' + ;
             '(PAD(DC_UserInfo(1),8)==usr_id.OR.Empty(usr_id))'
ENDIF
*/

bFilter := &('{||' + cFilter + '}')

dbClearFilter()

dbSetFilter( bFilter, cFilter )

GO TOP
SELE (nSaveArea)

RETURN .t.

* ----------------

STATIC FUNCTION _dcQuerySave ( cQueryExpr, cQueryName, lSaveNew, cAlias )

LOCAL GetList := {}, lOk, cFilter, nSaveArea := Select()

IF !_DCQValid( cQueryExpr )
  RETURN .f.
ENDIF

DEFAULT cQueryName := '', ;
        lSaveNew := .t., ;
        cAlias := Alias()

cQueryName := PAD(cQueryName,40)
@ 6,13 DCSAY DCQMSG_50_1 SAYSIZE 0
@ 7,14 DCGET cQueryName

DCREAD GUI ;
   EXPRESS ;
   FIT ;
   ADDBUTTONS ;
   TO lOk ;
   MODAL ;
   ENTEREXIT ;
   TITLE 'Save Query to Query Catalog'

IF !EMPTY(cQueryName) .AND. lOk
  SELE 'DCQUERY'
  cFilter := dbFilter()
  SET FILT TO
  IF lSaveNew
    GO TOP
    LOCA FOR EMPTY(DCQUERY->DBF_NAME)
  ENDIF
  IF EOF()
    IF !DC_ADDREC(2)
      RETURN .f.
    ENDIF
  ELSE
    IF !DC_RECLOCK(2)
      RETURN .f.
    ENDIF
  ENDIF
  REPLACE DCQUERY->DBF_NAME WITH cAlias, ;
          DCQUERY->DESC WITH cQueryName,;
          DCQUERY->QUERY WITH cQueryExpr
  UNLOCK
  IF !Empty(cFilter)
    dbSetFilter( &('{||'+cFilter+'}'),cFilter )
  ENDIF
  DC_MsgBox('QUERY: ' + Alltrim(cQueryName) + ' has been saved!')
  SELE (nSaveArea)
  RETURN .t.
ENDIF

SELE (nSaveArea)
RETURN .f.

* ------------------

STATIC FUNCTION _dcqvalid ( cQueryExpr, cAlias )

LOCAL nSaveArea := Select(), lStatus := .t.

DEFAULT cAlias := Alias()
IF DC_DbSel(cAlias)
  IF !EMPTY(cQueryExpr) .AND. TYPE(cQueryExpr)$'UE'
     DC_MSGBOX(,,{DCQMSG_35,'',;
                 SUBSTR(cQueryExpr,1,60),;
                 SUBSTR(cQueryExpr,61,60),;
                 SUBSTR(cQueryExpr,121,60),;
                 SUBSTR(cQueryExpr,181,60) },,.t.)
    lStatus := .f.
  ENDIF
ENDIF
SELE (nSaveArea )
RETURN lStatus

* -----------------

STATIC FUNCTION _dcqueryex ( cCompareTo )

LOCAL GetList := {}, lOk

@ 0,0 DCMULTILINE cCompareTo SIZE 50,3 ;
      NOHORIZSCROLL FONT '10.Courier'

@ 0,55 DCPUSHBUTTON CAPTION '&Fields' SIZE 9,1.2 ;
       ACTION {||_dcqueryfields(@cCompareTo), ;
                 DC_GetRefresh(GetList)}

DCREAD GUI EXPRESS FIT ADDBUTTONS MODAL TO lOk TITLE DCQMSG_57_2

IF lOk .AND. !EMPTY(cCompareTo)
  cCompareTo := CHR(255) + StrTran(cCompareTo,Chr(13)+Chr(10),'')
ELSE
  cCompareTo := ''
ENDIF

RETURN lOk

* ----------------

STATIC PROCEDURE _dcqueryfields( cCompareTo )

LOCAL cField := DC_Fields()
IF !Empty(cField)
  cCompareTo += cField
ENDIF
RETURN

* ----------------

STATIC FUNCTION _dctestquery( cQueryExpr )

LOCAL lError := .t., bErrorBlock := ErrorBlock({|e|_dctestqueryerror(e)}), ;
      lReturn

BEGIN SEQUENCE
lReturn := &(cQueryExpr)
lError := .f.
END SEQUENCE
IF Valtype(lReturn) = 'L'
  DC_MsgBox('Query Expression is Valid!')
ELSEIF !lError
  DC_MsgBox('Query Expression is INVALID!  Does not return a LOGICAL value')
ENDIF

ErrorBlock(bErrorBlock)

RETURN nil

* ----------------

STATIC PROCEDURE _dctestqueryerror(e)

LOCAL cInfo

cInfo :=   e:description+' '+e:operation+;
           IIF(!EMPTY(e:subsystem),;
           "  "+e:subsystem + "[" + LTrim(Str(e:subCode)) + "]",'')+;
           IIF(e:OSCode>0," OS Code["+LTrim(Str(e:OSCode))+"]",'')

DC_MsgBox( cInfo )

BREAK

RETURN

* ----------------

FUNCTION DC_QueryExpr ( cQueryName )

LOCAL nSaveArea := Select(), cQuery

PRIVATE _nOldArea, _aBrowse

IF !_DCQueryOpen()
  RETURN ''
ENDIF
LOCA FOR Alltrim(Upper(cQueryName)) == Alltrim(Upper(DCQUERY->desc))
cQuery := Alltrim(DCQUERY->query)
SELE (nSaveArea)
RETURN cQuery

/* ------------------------- */

FUNCTION dc_scope ( cMessage, lOk )

LOCAL nRecord, cRest, nRecs, cRecord, cRecs, cFor, cWhile,;
      aScope := ARRAY(9) , GetList := {}, xScope1, xScope2,;
      aSetKeys, nSaveRec, lGui := DC_Gui(.t.), GetOptions

lOk := .f.
IF Empty(Alias())
  DC_MsgBox({DC_SCPMSG_11,DC_SCPMSG_12})
  RETURN nil
ENDIF

cMessage := IIF(VALTYPE(cMessage)='C',cMessage,'')
BEGIN SEQUENCE
nRecord := RECNO()
nRecs := 0
cRest := 'T'
STORE SPACE(200) TO cFor, cWhile
STORE 'ALL     ' TO cRecord, cRecs

@  5,7 DCSAY DC_SCPMSG_4 GET cRecord PICT '@K@!' SAYSIZE 0

@  7,7 DCSAY DC_SCPMSG_2 SAYSIZE 43

@  8,8 DCGET cFor PICT '@S50' WHEN {||Upper(cRecord)='ALL'} ;
       GETSIZE 50

@  8,59 DCPUSHBUTTON CAPTION 'Builder' SIZE 8,1 ;
   ACTION {||cFor := _Query(cFor), ;
             IIF(cFor==nil,cFor:='',nil), ;
             cFor := Pad(cFor,200), ;
             DC_GetRefresh(GetList)}

@  8,68 DCPUSHBUTTON CAPTION 'Fields' SIZE 8,1 ;
   ACTION {||cFor := Trim(cFor) + DC_Do('DC_Fields()'), DC_GetRefresh(GetList)}

@ 10,7 DCSAY DC_SCPMSG_3 SAYSIZE 43

@ 11,8 DCGET cWhile PICT '@S50' WHEN {||Upper(cRecord)='ALL'} ;
       GETSIZE 50

@ 11,59 DCPUSHBUTTON CAPTION 'Builder' SIZE 8,1 ;
   ACTION {||cWhile := _Query(cWhile), ;
             IIF(cWhile==nil,cWhile:='',nil), ;
             cWhile := Pad(cWhile,200), ;
             DC_GetRefresh(GetList)}

@ 11,68 DCPUSHBUTTON CAPTION 'Fields' SIZE 8,1 ;
   ACTION {||cWhile := Trim(cWhile) + DC_Do('DC_Fields()'), DC_GetRefresh(GetList)}

@ 13,7 DCSAY DC_SCPMSG_5 GET cRest PICT '!' VALID {||cRest $ 'CT'} ;
       WHEN {||Upper(cRecord)='ALL'} SAYSIZE 0 SAYRIGHT

@ 15,7 DCSAY DC_SCPMSG_6 GET cRecs PICT '@K@!' ;
       WHEN {||Upper(cRecord)='ALL'} SAYSIZE 0 SAYRIGHT

IF IndexOrd() > 0
  IF Valtype(DC_SetScope(0))#'U'
    xScope1 := DC_SetScope(0)
    xScope2 := DC_SetScope(1)
    IF Valtype(&(IndexKey(0)))#Valtype(xScope1)
      xScope1 := &(INDEXKEY(0))
      xScope2 := &(INDEXKEY(0))
    ELSEIF Valtype(xScope1)='C'
      xScope1 := PAD(xScope1,LEN(&(INDEXKEY(0))))
      xScope2 := PAD(xScope2,LEN(&(INDEXKEY(0))))
    ENDIF
  ELSE
    nSaveRec := RecNo()
    GO BOTTOM
    SKIP
    xScope1 := &(INDEXKEY(0))
    xScope2 := &(INDEXKEY(0))
    GO nSaveRec
  ENDIF

  @ 17,7 DCSAY DC_SCPMSG_9  GET xScope1 PICT '@S30' ;
         WHEN {||Upper(cRecord)='ALL'} SAYSIZE 28 SAYRIGHT

  @ 18,7 DCSAY DC_SCPMSG_10 GET xScope2 PICT '@S30' ;
         WHEN {||Upper(cRecord)='ALL'} SAYSIZE 28 SAYRIGHT

ENDIF

DCGETOPTIONS HIDE
DCREAD GUI EXPRESS FIT ADDBUTTONS TO lOk MODAL ;
   ENTEREXIT ;
   OPTIONS GetOptions ;
   TITLE DC_SCPMSG_1 + IIF(!EMPTY(cMessage),' for '+cMessage,'') ;
   EVAL {|o|DC_CenterObject(o,SetAppWindow()),o:show(),SetAppWindow(o)}

IF !lOk
  BREAK
ENDIF
DO CASE
  CASE cRecord = 'ALL'
    nRecord := 0
  CASE cRecord = 'CUR'
    nRecord := RECNO()
  OTHERWISE
    nRecord := VAL(cRecord)
ENDCASE
DO CASE
  CASE cRecs = 'ALL'
    nRecs := 0
  OTHERWISE
    nRecs := VAL(cRecs)
ENDCASE
IF !EMPTY(cFor)
  IF TYPE( cFor ) $ 'UE'
    DC_MsgBox( DC_SCPMSG_7 )
  ELSE
    cFor := TRIM(cFor)
    DCSCOPE_FORBLOCK := {||&cFor}
    DCSCOPE_FOREXPR := cFor
  ENDIF
ENDIF
IF Valtype(xScope1)='C'
 xScope1 := TRIM(xScope1)
 xScope2 := TRIM(xScope2)
ENDIF
IF !EMPTY(cWhile)
  IF TYPE( cWhile ) $ 'UE'
    DC_MsgBox( DC_SCPMSG_8 )
  ELSE
    cWhile := TRIM(cWhile)
    IF Valtype(xScope1)#'U'
      DCSCOPE_WHILEBLOCK := {||&(cWhile).AND.&(IndexKey(0))<=xScope2.AND.Inkey()#27}
    ELSE
      DCSCOPE_WHILEBLOCK := {||&(cWhile).AND.INKEY()#27}
    ENDIF
    DCSCOPE_WHILEEXPR := cWhile
  ENDIF
ELSEIF Valtype(xScope1)#'U'
  DCSCOPE_WHILEBLOCK := {||&(IndexKey(0))<=xScope2.AND.Inkey()#27}
ENDIF
IF nRecs # 0
  DCSCOPE_RECORDS := nRecs
ENDIF
IF nRecord # 0
  DCSCOPE_RECNO := nRecord
ENDIF
IF cRest = 'C'
  DCSCOPE_REST := .t.
ELSE
  GO TOP
ENDIF
IF Valtype(xScope1)#'U'
  SEEK xScope1
ENDIF
DCSCOPE_TOP    := xScope1
DCSCOPE_BOTTOM := xScope2
END SEQUENCE
DC_Gui(lGui)

RETURN aScope

* -------------------

STATIC FUNCTION _Query( cQuery )

cQuery := DC_QueryBuild(cQuery)

RETURN cQuery



*qw
************************************
* PRAVA DO SLOVENINY
************************************


**************************************
FUNCTION DC_QueryBuild_sk ( cQueryExpr, cQueryName, cField, aFieldItems )
**************************

LOCAL nSequence, GetList := {}, oFileMenu, oMenuBar, bQueryAction, ;
      cOldQuery, aQueryBuild[21], oOperationStatic, oFieldsStatic, ;
      nFieldPointer, oLogicalStatic, oQueryCatalogStatic, ;
      nOperatorPointer, aFields, aOperators, i, ;
      oOperatorStatic, lOk, GetOptions, bFieldAction, bOperatorAction, ;
      oAndButton, oOrButton, oAndNotButton, oOrNotButton, oFieldButton, ;
      oQueryButton, oTaggedButton, oDeletedButton

STORE '' TO cDCQUERY_FIELDTYPE, cDCQUERY_OPERATOR, cDCQUERY_ANDOR, ;
            cDCQUERY_FIELDNAME, cDCQUERY_FIELDDESC

DEFAULT cQueryName := '<no name>', ;
        cQueryExpr := dbFilter()

*qqq doplnenie zistenia aktulneho aliasu databzy, aby korektne potom filtrovalo
*    niie potom je tento alias doplnen do query ka ku nzvu poa 
pomalias:=alias()

nFieldPointer := 1

IF !_DCQueryOpen()
  RETURN ''
ENDIF

aDCQUERY_QUERYARRAY := {''}

IF !EMPTY(cField)
  cDCQUERY_QUERYEXPRESSION := ''
ELSE
  cDCQUERY_QUERYEXPRESSION := Alltrim(cQueryExpr)
ENDIF

IF !Empty(cQueryExpr)
  AAdd(aDCQUERY_QUERYARRAY,cQueryExpr)
ENDIF

lDCQUERY_QUICK_QUERY := .f.
IF !Empty(cQueryExpr)
  nSequence := nDCQUERY_PICKLOGICAL
ELSEIF !Empty(cField)
  nSequence := nDCQUERY_PICKOPERATOR
  cDCQUERY_FIELDDESC := cField
  cDCQUERY_FIELDTYPE := Type(cField)
  lDCQUERY_QUICK_QUERY := .t.
ELSE
  nSequence := nDCQUERY_PICKOPERATION
ENDIF

cDCQUERY_FIELDNAME := cField

IF Valtype(aFieldItems) # 'A'
  aFields := DC_FieldArray(.f.,,,,.t.)
  aFieldItems := aFields[2]
ELSE
  FOR i := 1 TO LEN(aFieldItems)
    IF Len(aFieldItems[i]) < 8
      ASize(aFieldItems[i],8)
    ENDIF
  NEXT
ENDIF

aDCQUERY_GETLIST := GetList


/* ----- Menu ----- */

DCMENUBAR oMenuBar OWNERDRAW

  DCSUBMENU oFileMenu PARENT oMenuBar PROMPT '&Sbor'

    DCMENUITEM 'Nahraj Dotaz do Katalgu' PARENT oFileMenu ;
      ACTION {||_DCQuerySave(cDCQUERY_QUERYEXPRESSION)} ;
      WHEN {||!Empty(cDCQUERY_QUERYEXPRESSION)}

    DCMENUITEM 'Test Dotazu' PARENT oFileMenu ;
      ACTION {||DC_GetRefresh(GetList), ;
                _dctestquery(cDCQUERY_QUERYEXPRESSION)} ;
      WHEN {||!Empty(cDCQUERY_QUERYEXPRESSION)}

    DCMENUITEM 'Koniec' PARENT oFileMenu ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

/* ----- Query Catalog Window ----- */

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      OBJECT oQueryCatalogStatic ;
      HIDE {||nSequence <> nDCQUERY_PICKQUERY } ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT oQueryCatalogStatic

@ .5,2 DCSAY {||'Katalg dotazov pre databzu ' + Alias() } ;
      FONT '10.Arial' COLOR GRA_CLR_BLUE ;
      SAYSIZE 50 ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y

@13,2 DCPUSHBUTTON CAPTION '&Sp' SIZE 9,1.2 ;
      ACTION {||nSequence := nDCQUERY_PICKOPERATION, ;
                DC_GetRefresh(GetList) }

bQueryAction := ;
    {|| cDCQUERY_QUERYPICKEXPR := Alltrim(DCQUERY->query), ;
        nSequence := nDCQUERY_SELECTQUERY, ;
        QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@13,13 DCPUSHBUTTON CAPTION '&alej' SIZE 9,1.2 ;
       ACTION bQueryAction

@13,24 DCPUSHBUTTON CAPTION '&Vyma' SIZE 9,1.2 ;
       ACTION {||nSequence := nDCQUERY_DELETEQUERY, ;
                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer), ;
                 nSequence := nDCQUERY_PICKQUERY}

@ 1.5,2 DCBROWSE oDCQUERY_BROW_QUERY ALIAS 'DCQUERY' SIZE 56,11 ;
      PRESENTATION DC_BrowPres() ;
      NOSOFTTRACK ;
      ID 'DCQUERY_BROWSE_CATALOG' ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      DATALINK bQueryAction

DCSETPARENT oDCQUERY_BROW_QUERY

DCBROWSECOL FIELD DCQUERY->desc HEADER 'Popis' WIDTH 10
DCBROWSECOL FIELD DCQUERY->query HEADER 'Obsah dotazu' WIDTH 18
DCBROWSECOL FIELD DCQUERY->dbf_name HEADER 'Alias' WIDTH 10

/* ----- Logical Operator Window ----- */

DCSETPARENT TO

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      OBJECT oLogicalStatic ;
      HIDE {||nSequence <> nDCQUERY_PICKLOGICAL } ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT TO oLogicalStatic

@ 1,15 DCPUSHBUTTON CAPTION '.AND.' FONT '10.Arial Bold' ;
       SIZE 30,1.5 ;
       TOOLTIP 'The next item added to the Query Expression will;' + ;
               'be logically ANDed with the current query' ;
       TABGROUP XBP_BEGIN_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oAndButton ;
       ACTION {|| cDCQUERY_ANDOR := ' .AND. ', ;
                  nSequence := nDCQUERY_PICKOPERATION, ;
                  DC_GetRefresh(GetList), ;
                  cDCQUERY_ANDOR_BUTTON := oAndButton, ;
                  QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 3,15 DCPUSHBUTTON CAPTION '.OR.' FONT '10.Arial Bold' ;
       SIZE 30,1.5 ;
       TOOLTIP 'The next item added to the Query Expression will;' + ;
               'be logically ORed with the current query' ;
       TABGROUP XBP_WITHIN_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oOrButton ;
       ACTION {|| cDCQUERY_ANDOR := ' .OR. ', ;
                  IIF( !Empty(cDCQUERY_QUERYEXPRESSION), ;
                    cDCQUERY_QUERYEXPRESSION := '(' + cDCQUERY_QUERYEXPRESSION + ')',nil) , ;
                  IIF( !Empty(cDCQUERY_QUERYEXPRESSION), ;
                    AAdd(aDCQUERY_QUERYARRAY,cDCQUERY_QUERYEXPRESSION),nil), ;
                  nSequence := nDCQUERY_PICKOPERATION, ;
                  DC_GetRefresh(GetList), ;
                  cDCQUERY_ANDOR_BUTTON := oOrButton, ;
                  QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 5,15 DCPUSHBUTTON CAPTION '.AND. .NOT.' FONT '10.Arial Bold' ;
       SIZE 30,1.5 ;
       TOOLTIP 'The next item added to the Query Expression will;' + ;
               'be logically ANDed with the current query and negated' ;
       TABGROUP XBP_WITHIN_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oAndNotButton ;
       ACTION {|| cDCQUERY_ANDOR := ' .AND. !', ;
                  nSequence := nDCQUERY_PICKOPERATION, ;
                  DC_GetRefresh(GetList), ;
                  cDCQUERY_ANDOR_BUTTON := oAndNotButton, ;
                  QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 7,15 DCPUSHBUTTON CAPTION '.OR. .NOT.' FONT '10.Arial Bold' ;
       SIZE 30,1.5 ;
       TOOLTIP 'The next item added to the Query Expression will;' + ;
               'be logically ORed with the current query and negated' ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oOrNotButton ;
       TABGROUP XBP_WITHIN_GROUP ;
       ACTION {|| cDCQUERY_ANDOR := ' .OR. !', ;
                  IIF( !Empty(cDCQUERY_QUERYEXPRESSION), ;
                     cDCQUERY_QUERYEXPRESSION := '(' + cDCQUERY_QUERYEXPRESSION + ')',nil), ;
                  nSequence := nDCQUERY_PICKOPERATION, ;
                  DC_GetRefresh(GetList), ;
                  cDCQUERY_ANDOR_BUTTON := oOrNotButton, ;
                  QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 9,15 DCPUSHBUTTON CAPTION 'VYMA DOTAZ' FONT '10.Arial Bold' ;
       SIZE 30,1.5 ;
       TOOLTIP 'Clear the Query Expression and Start Over' ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       TABGROUP XBP_WITHIN_GROUP ;
       ACTION {|| cDCQUERY_ANDOR := '', ;
                  cDCQUERY_QUERYEXPRESSION := '', ;
                  nSequence := nDCQUERY_PICKOPERATION, ;
                  DC_GetRefresh(GetList), ;
                  QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@11,15 DCPUSHBUTTON CAPTION '&SP' FONT '10.Arial Bold' ;
       SIZE 30,1.5 ;
       TOOLTIP 'Undo the last addition to the Query Expression' ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       TABGROUP XBP_WITHIN_GROUP ;
       ACTION {|| IIF( Len(aDCQUERY_QUERYARRAY) > 1, ;
                       ASize(aDCQUERY_QUERYARRAY,Len(aDCQUERY_QUERYARRAY)-1),nil), ;
                  IIF( Len(aDCQUERY_QUERYARRAY) == 1, ;
                       nSequence := nDCQUERY_PICKOPERATION,nil ), ;
                  IIF( Len(aDCQUERY_QUERYARRAY) == 1, ;
                       cDCQUERY_ANDOR := '',nil), ;
                  cDCQUERY_QUERYEXPRESSION := ATail(aDCQUERY_QUERYARRAY), ;
                  DC_GetRefresh(GetList) }

@13,15 DCPUSHBUTTON CAPTION 'UKONI' FONT '10.Arial Bold' ;
       SIZE 30,1.5 ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       TABGROUP XBP_END_GROUP ;
       ACTION {|| cDCQUERY_ANDOR := 'DONE', ;
                  DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

/* ----- Choose Type of Item Window (Field, Query, etc.) ----- */

DCSETPARENT TO

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      HIDE {||!(nSequence == nDCQUERY_PICKOPERATION) } ;
      OBJECT oOperationStatic ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT TO oOperationStatic

@ 1,15 DCPUSHBUTTON CAPTION '&Vber zo zoznamu pol' FONT '10.Arial BOLD' ;
       TOOLTIP 'Add a comparison value to the Query Expression by;' + ;
               'selecting a field and an operator from the database' ;
       SIZE 30,1.5 ;
       TABGROUP XBP_BEGIN_GROUP ;
       OBJECT oFieldButton ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       ACTION {||nSequence := nDCQUERY_PICKFIELD, ;
                 cDCQUERY_OPERATION_BUTTON := oFieldButton, ;
                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 3,15 DCPUSHBUTTON CAPTION '&Vber zo zoznamu dotazov' FONT '10.Arial BOLD' ;
       SIZE 30,1.5 ;
       TABGROUP XBP_WITHIN_GROUP ;
       TOOLTIP 'Add a comparison value to the Query Expression by;' + ;
               'selecting a saved query expression from the QUERY catalog' ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       OBJECT oQueryButton ;
       ACTION {||nSequence := nDCQUERY_PICKQUERY, ;
                 cDCQUERY_OPERATION_BUTTON := oQueryButton, ;
                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

*@ 5,15 DCPUSHBUTTON CAPTION '&Zmazan' FONT '10.Arial BOLD' ;
*       TOOLTIP 'Add the DELETED() function to the Query Expression;' + ;
*               'to only select records that are Deleted or NOT Deleted' ;
*       TABGROUP XBP_WITHIN_GROUP ;
*       SIZE 30,1.5 ;
*       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
*       OBJECT oDeletedButton ;
*       ACTION {||nSequence := nDCQUERY_PICKDELETED, ;
*                 cDCQUERY_OPERATION_BUTTON := oDeletedButton, ;
*                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

*@ 7,15 DCPUSHBUTTON CAPTION '&Tagged' FONT '10.Arial BOLD' ;
*       TOOLTIP 'Add the DC_TAGGED() function to the Query Expression;' + ;
*               'to only select records that are Tagged or NOT Tagged' ;
*       SIZE 30,1.5 ;
*       TABGROUP XBP_WITHIN_GROUP ;
*       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
*       OBJECT oTaggedButton ;
*       ACTION {||nSequence := nDCQUERY_PICKTAGGED, ;
*                 cDCQUERY_OPERATION_BUTTON := oTaggedButton, ;
*                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@ 9,15 DCPUSHBUTTON CAPTION '&Zadanie' FONT '10.Arial BOLD' ;
       SIZE 30,1.5 ;
       TABGROUP XBP_WITHIN_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       TOOLTIP 'Add an Expression to the current Query Expression' ;
       ACTION {||nSequence := nDCQUERY_PICKEXPRESSION, ;
                 QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@11,15 DCPUSHBUTTON CAPTION '&Sp' FONT '10.Arial BOLD' ;
       SIZE 30,1.5 ;
       TABGROUP XBP_END_GROUP ;
       RESIZE { DCGUI_REPOS_CENTER_X_BLOCK, nil } ;
       ACTION {||nSequence := nDCQUERY_PICKLOGICAL, ;
                 DC_GetRefresh(GetList)} ;
       WHEN {||!Empty(cDCQUERY_QUERYEXPRESSION)}


DCSETPARENT TO

/* ----- Choose Field Window ----- */

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      OBJECT oFieldsStatic ;
      HIDE {|| !(nSequence == nDCQUERY_PICKFIELD) } ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT TO oFieldsStatic

@ .5,2 DCSAY {||IIF( Empty(cDCQUERY_ANDOR),'Vyber pole', ;
                'Choose a Field to ' + cDCQUERY_ANDOR + ;
                ' to Query in Window' ) } ;
      FONT '10.Arial' COLOR GRA_CLR_BLUE ;
      SAYSIZE 50 ;
      RESIZE DCGUI_RESIZE_REPOSONLY_Y

@13,2 DCPUSHBUTTON CAPTION '&Sp' SIZE 9,1.2 ;
      ACTION {||nSequence := nDCQUERY_PICKOPERATION, ;
                DC_GetRefresh(GetList) }

*qqq povodny code block
/*
bFieldAction := ;
    {|| cDCQUERY_FIELDNAME := aFieldItems[nFieldPointer,DCFLD_NAME], ;
        cDCQUERY_FIELDDESC := aFieldItems[nFieldPointer,DCFLD_DESC], ;
        cDCQUERY_FIELDTYPE := aFieldItems[nFieldPointer,DCFLD_TYPE], ;
        nDCQUERY_FIELDLEN := aFieldItems[nFieldPointer,DCFLD_LEN], ;
        nSequence := nDCQUERY_PICKOPERATOR, ;
        _FilterOperatorArray( aOperators, cDCQUERY_FIELDTYPE ), ;
        DC_GetRefresh(GetList), ;
        QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}
*/

*qqq upraveny s doplnenm aliasu, ale vraciam sp pvodn lebo problmy to nevyrieilo, mono potom listing filtrovanych

bFieldAction := ;
    {|| cDCQUERY_FIELDNAME := "("+pomalias+"->"+aFieldItems[nFieldPointer,DCFLD_NAME]+")", ;
        cDCQUERY_FIELDDESC := aFieldItems[nFieldPointer,DCFLD_DESC], ;
        cDCQUERY_FIELDTYPE := aFieldItems[nFieldPointer,DCFLD_TYPE], ;
        nDCQUERY_FIELDLEN := aFieldItems[nFieldPointer,DCFLD_LEN], ;
        nSequence := nDCQUERY_PICKOPERATOR, ;
        _FilterOperatorArray( aOperators, cDCQUERY_FIELDTYPE ), ;
        DC_GetRefresh(GetList), ;
        QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}


@13,13 DCPUSHBUTTON CAPTION '&alej' SIZE 9,1.2 ;
       ACTION bFieldAction

@ 1.5,2 DCBROWSE oDCQUERY_BROW_FIELDS DATA aFieldItems SIZE 56,11 ;
      PRESENTATION DC_BrowPres() ;
      POINTER nFieldPointer ;
      NOSOFTTRACK ;
      NOHSCROLL ;
      ;// FIT ;
      ID 'DCQUERY_BROWSE_FIELDITEMS' ;
      DATALINK bFieldAction ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT TO oDCQUERY_BROW_FIELDS
DCBROWSECOL ELEMENT DCFLD_DESC WIDTH 15 HEADER 'Popis poa'
DCBROWSECOL ELEMENT DCFLD_NAME WIDTH 7 HEADER 'Nzov poa'
DCBROWSECOL ELEMENT DCFLD_TYPE WIDTH 3 HEADER 'Typ'
DCBROWSECOL ELEMENT DCFLD_LEN WIDTH 3 HEADER 'Dka'
DCBROWSECOL ELEMENT DCFLD_DEC WIDTH 3 HEADER 'Dec'

DCSETPARENT TO

/* ----- Choose Operator Window ----- */

@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      OBJECT oOperatorStatic ;
      HIDE {||nSequence # nDCQUERY_PICKOPERATOR} ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

aOperators := _OperatorArray()

DCSETPARENT TO oOperatorStatic


@ .5,2 DCSAY {||'Vyber opertor pre ' + Upper(Alltrim(cDCQUERY_FIELDDESC))};
       FONT '10.Arial' COLOR GRA_CLR_BLUE ;
       SAYSIZE 50 ;
       RESIZE DCGUI_RESIZE_REPOSONLY_Y

@13,2 DCPUSHBUTTON CAPTION '&Sp' SIZE 9,1.2 ;
      ACTION {||nSequence := nDCQUERY_PICKFIELD, ;
                DC_GetRefresh(GetList), ;
                SetAppFocus(oDCQUERY_BROW_FIELDS) }

nOperatorPointer := 1
bOperatorAction := ;
      {|| cDCQUERY_OPERATOR := aOperators[nOperatorPointer,2], ;
          nSequence := nDCQUERY_PICKVALUE, ;
          DC_GetRefresh(GetList), ;
          QuerySequence(@nSequence,aQueryBuild,aFieldItems,nFieldPointer)}

@13,13 DCPUSHBUTTON CAPTION '&alej' SIZE 9,1.2 ;
       ACTION bOperatorAction

@ 1.5,2 DCBROWSE oDCQUERY_BROW_OPERATORS DATA aOperators SIZE 55,11 ;
      PRESENTATION DC_BrowPres() ;
      FONT '10.Courier New' ;
      NOHSCROLL ;
      NOSOFTTRACK ;
      RESIZE DCGUI_RESIZE_RESIZEONLY ;
      POINTER nOperatorPointer ;
      ITEMSELECTED bOperatorAction

DCSETPARENT TO oDCQUERY_BROW_OPERATORS
DCBROWSECOL ELEMENT 1 WIDTH 50 HEADER 'Operator'

/* ----- Enter a Value Window ----- */

DCSETPARENT TO
@ 0,0 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX SIZE 60,15 ;
      OBJECT oDCQUERY_VALUESTATIC ;
      HIDE {||!(nSequence == nDCQUERY_PICKVALUE) } ;
      RESIZE DCGUI_RESIZE_RESIZEONLY

DCSETPARENT TO

*qqq 1.8.2016 - prava iba zmena fontu z 8.Alaska Crt na fontnt  pre zobrazenie stavu dotazu
********************************************************************************************

/* ----- Query Expression Window ----- */

@15,0 DCSAY 'Stav dotazu*:' SAYSIZE 0 FONT '10.Arial' ;
      COLOR GRA_CLR_BLUE

*qqq pvodn font
*      FONT '8.Alaska Crt' ;

@16,0 DCMULTILINE cDCQUERY_QUERYEXPRESSION SIZE 49,4 ;
      OBJECT oDCQUERY_MEMOOBJECT ;
      NOHORIZSCROLL ;
      FONT fontnt ;
      RESIZE DCGUI_RESIZE_RESIZEONLY_X

@16,51 DCPUSHBUTTON CAPTION '&Ok' SIZE 9,1.2  ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} ;
      WHEN {||!Empty(cDCQUERY_QUERYEXPRESSION)} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_X

@18,51 DCPUSHBUTTON CAPTION '&Storno' SIZE 9,1.2  ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_ABORT,aDCQUERY_GETLIST2), ;
                DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
      RESIZE DCGUI_RESIZE_REPOSONLY_X

DCGETOPTIONS ABORTQUERY ;
             CLOSEQUERY ;
             HILITEGETS GRA_CLR_RED ;
             TABSTOP ;
             RESIZE

DCREAD GUI ;
   ;// EXPRESS ;
   FIT ;
   MODAL ;
   TO lOk ;
   TITLE 'Sprievodca Dotazom' ;
   SETAPPWINDOW ;
   OPTIONS GetOptions ;
   EVAL {|o|cDCQUERY_ANDOR_BUTTON := oAndButton, ;
            cDCQUERY_OPERATION_BUTTON := oFieldButton, ;
            SetAppFocus(IIF(!Empty(cField),oDCQUERY_BROW_OPERATORS:getColumn(1),oFieldButton)) }

/* if after all that the cQueryExpr is empty, restore the old query */
IF EMPTY(ALLTRIM(cDCQUERY_QUERYEXPRESSION))
  cDCQUERY_QUERYEXPRESSION  :=  cOldQuery
ENDIF
DC_ClearEvents()

RETURN cDCQUERY_QUERYEXPRESSION

